"use strict";
this.name	= "headlights";
this.author	= "Norby";
this.copyright	= "2014 Norby";
this.description= "Tune the light level on the dark side of objects";
this.licence	= "CC BY-NC-SA 4.0";

//internal properties, should not touch
this.$Level = 1; //darker than the default but not "too" dark as 0.1 in Realistic Stars

//equipment events
this.activated = function() { //increase ambient level
	var w = worldScripts["headlights"];
	w.$eq(true, w);
}

this.mode = function() { //decrease ambient level
	var w = worldScripts["headlights"];
	w.$eq(false, w);
}

//worldscript events
this.startUp = function() {
	var l = missionVariables.$HeadlightsLevel;
	if( l ) {
		this.$Level = l;
		if( system.ambientLevel ) system.ambientLevel = l;
	}
}

this.playerBoughtEquipment = function(equipmentKey) {
	if( equipmentKey == "EQ_Headlights_REMOVE" ) {
		var eq = equipmentKey.substr( 0, equipmentKey.length-7 );//the real eq
		player.ship.removeEquipment( eq ); //remove it
		player.ship.removeEquipment( equipmentKey ); //remove the "bought" remove eq
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$HeadlightsLevel = this.$Level;
}

this.shipWillExitWitchspace = function() {
	system.ambientLevel = this.$Level; //force in every system
}

//headlights functions
this.$eq = function(up, w) { //decrease ambient level
	if( !system.ambientLevel ) {
		player.consoleMessage("You need Oolite 1.81 to use this equipment"
			+" but you can change ambient_level by hand in Config/planetinfo.plist", 10);
		return;
	}
	var step = 0.05;
	if( w.$Level > 1.5 || up && w.$Level == 1.5 ) step = 0.5;
	if( w.$Level < 0.05 ) w.$Level = 0;
	if( up ) {
		w.$Level += step;
		if( w.$Level > 10 ) w.$Level = 0.01;
	} else {
		w.$Level -= step;
		if( w.$Level < 0 ) w.$Level = 10;
	}
	if(w.$Level == 0) w.$Level = 0.01;
	w.$Level = Math.round(w.$Level*100)/100;
	system.ambientLevel = w.$Level;
	player.consoleMessage("Headlights set to "+w.$Level, 3);
}
